/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the WriterDebugResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WriterDebugResponse{}

// WriterDebugResponse struct for WriterDebugResponse
type WriterDebugResponse struct {
	Status           *string                       `json:"status,omitempty"`
	Message          *string                       `json:"message,omitempty"`
	Started          NullableFloat32               `json:"started,omitempty"`
	Ended            NullableFloat32               `json:"ended,omitempty"`
	Duration         NullableString                `json:"duration,omitempty"`
	MemoryMb         NullableInt32                 `json:"memory_mb,omitempty"`
	ConnectionResult NullableOneOfConnectionResult `json:"connectionResult,omitempty"`
}

// NewWriterDebugResponse instantiates a new WriterDebugResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWriterDebugResponse() *WriterDebugResponse {
	this := WriterDebugResponse{}
	return &this
}

// NewWriterDebugResponseWithDefaults instantiates a new WriterDebugResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWriterDebugResponseWithDefaults() *WriterDebugResponse {
	this := WriterDebugResponse{}
	return &this
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *WriterDebugResponse) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriterDebugResponse) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *WriterDebugResponse) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *WriterDebugResponse) SetStatus(v string) {
	o.Status = &v
}

// GetMessage returns the Message field value if set, zero value otherwise.
func (o *WriterDebugResponse) GetMessage() string {
	if o == nil || IsNil(o.Message) {
		var ret string
		return ret
	}
	return *o.Message
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriterDebugResponse) GetMessageOk() (*string, bool) {
	if o == nil || IsNil(o.Message) {
		return nil, false
	}
	return o.Message, true
}

// HasMessage returns a boolean if a field has been set.
func (o *WriterDebugResponse) HasMessage() bool {
	if o != nil && !IsNil(o.Message) {
		return true
	}

	return false
}

// SetMessage gets a reference to the given string and assigns it to the Message field.
func (o *WriterDebugResponse) SetMessage(v string) {
	o.Message = &v
}

// GetStarted returns the Started field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriterDebugResponse) GetStarted() float32 {
	if o == nil || IsNil(o.Started.Get()) {
		var ret float32
		return ret
	}
	return *o.Started.Get()
}

// GetStartedOk returns a tuple with the Started field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriterDebugResponse) GetStartedOk() (*float32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Started.Get(), o.Started.IsSet()
}

// HasStarted returns a boolean if a field has been set.
func (o *WriterDebugResponse) HasStarted() bool {
	if o != nil && o.Started.IsSet() {
		return true
	}

	return false
}

// SetStarted gets a reference to the given NullableFloat32 and assigns it to the Started field.
func (o *WriterDebugResponse) SetStarted(v float32) {
	o.Started.Set(&v)
}

// SetStartedNil sets the value for Started to be an explicit nil
func (o *WriterDebugResponse) SetStartedNil() {
	o.Started.Set(nil)
}

// UnsetStarted ensures that no value is present for Started, not even an explicit nil
func (o *WriterDebugResponse) UnsetStarted() {
	o.Started.Unset()
}

// GetEnded returns the Ended field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriterDebugResponse) GetEnded() float32 {
	if o == nil || IsNil(o.Ended.Get()) {
		var ret float32
		return ret
	}
	return *o.Ended.Get()
}

// GetEndedOk returns a tuple with the Ended field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriterDebugResponse) GetEndedOk() (*float32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Ended.Get(), o.Ended.IsSet()
}

// HasEnded returns a boolean if a field has been set.
func (o *WriterDebugResponse) HasEnded() bool {
	if o != nil && o.Ended.IsSet() {
		return true
	}

	return false
}

// SetEnded gets a reference to the given NullableFloat32 and assigns it to the Ended field.
func (o *WriterDebugResponse) SetEnded(v float32) {
	o.Ended.Set(&v)
}

// SetEndedNil sets the value for Ended to be an explicit nil
func (o *WriterDebugResponse) SetEndedNil() {
	o.Ended.Set(nil)
}

// UnsetEnded ensures that no value is present for Ended, not even an explicit nil
func (o *WriterDebugResponse) UnsetEnded() {
	o.Ended.Unset()
}

// GetDuration returns the Duration field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriterDebugResponse) GetDuration() string {
	if o == nil || IsNil(o.Duration.Get()) {
		var ret string
		return ret
	}
	return *o.Duration.Get()
}

// GetDurationOk returns a tuple with the Duration field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriterDebugResponse) GetDurationOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Duration.Get(), o.Duration.IsSet()
}

// HasDuration returns a boolean if a field has been set.
func (o *WriterDebugResponse) HasDuration() bool {
	if o != nil && o.Duration.IsSet() {
		return true
	}

	return false
}

// SetDuration gets a reference to the given NullableString and assigns it to the Duration field.
func (o *WriterDebugResponse) SetDuration(v string) {
	o.Duration.Set(&v)
}

// SetDurationNil sets the value for Duration to be an explicit nil
func (o *WriterDebugResponse) SetDurationNil() {
	o.Duration.Set(nil)
}

// UnsetDuration ensures that no value is present for Duration, not even an explicit nil
func (o *WriterDebugResponse) UnsetDuration() {
	o.Duration.Unset()
}

// GetMemoryMb returns the MemoryMb field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriterDebugResponse) GetMemoryMb() int32 {
	if o == nil || IsNil(o.MemoryMb.Get()) {
		var ret int32
		return ret
	}
	return *o.MemoryMb.Get()
}

// GetMemoryMbOk returns a tuple with the MemoryMb field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriterDebugResponse) GetMemoryMbOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.MemoryMb.Get(), o.MemoryMb.IsSet()
}

// HasMemoryMb returns a boolean if a field has been set.
func (o *WriterDebugResponse) HasMemoryMb() bool {
	if o != nil && o.MemoryMb.IsSet() {
		return true
	}

	return false
}

// SetMemoryMb gets a reference to the given NullableInt32 and assigns it to the MemoryMb field.
func (o *WriterDebugResponse) SetMemoryMb(v int32) {
	o.MemoryMb.Set(&v)
}

// SetMemoryMbNil sets the value for MemoryMb to be an explicit nil
func (o *WriterDebugResponse) SetMemoryMbNil() {
	o.MemoryMb.Set(nil)
}

// UnsetMemoryMb ensures that no value is present for MemoryMb, not even an explicit nil
func (o *WriterDebugResponse) UnsetMemoryMb() {
	o.MemoryMb.Unset()
}

// GetConnectionResult returns the ConnectionResult field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriterDebugResponse) GetConnectionResult() OneOfConnectionResult {
	if o == nil || IsNil(o.ConnectionResult.Get()) {
		var ret OneOfConnectionResult
		return ret
	}
	return *o.ConnectionResult.Get()
}

// GetConnectionResultOk returns a tuple with the ConnectionResult field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriterDebugResponse) GetConnectionResultOk() (*OneOfConnectionResult, bool) {
	if o == nil {
		return nil, false
	}
	return o.ConnectionResult.Get(), o.ConnectionResult.IsSet()
}

// HasConnectionResult returns a boolean if a field has been set.
func (o *WriterDebugResponse) HasConnectionResult() bool {
	if o != nil && o.ConnectionResult.IsSet() {
		return true
	}

	return false
}

// SetConnectionResult gets a reference to the given NullableOneOfConnectionResult and assigns it to the ConnectionResult field.
func (o *WriterDebugResponse) SetConnectionResult(v OneOfConnectionResult) {
	o.ConnectionResult.Set(&v)
}

// SetConnectionResultNil sets the value for ConnectionResult to be an explicit nil
func (o *WriterDebugResponse) SetConnectionResultNil() {
	o.ConnectionResult.Set(nil)
}

// UnsetConnectionResult ensures that no value is present for ConnectionResult, not even an explicit nil
func (o *WriterDebugResponse) UnsetConnectionResult() {
	o.ConnectionResult.Unset()
}

func (o WriterDebugResponse) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WriterDebugResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.Message) {
		toSerialize["message"] = o.Message
	}
	if o.Started.IsSet() {
		toSerialize["started"] = o.Started.Get()
	}
	if o.Ended.IsSet() {
		toSerialize["ended"] = o.Ended.Get()
	}
	if o.Duration.IsSet() {
		toSerialize["duration"] = o.Duration.Get()
	}
	if o.MemoryMb.IsSet() {
		toSerialize["memory_mb"] = o.MemoryMb.Get()
	}
	if o.ConnectionResult.IsSet() {
		toSerialize["connectionResult"] = o.ConnectionResult.Get()
	}
	return toSerialize, nil
}

type NullableWriterDebugResponse struct {
	value *WriterDebugResponse
	isSet bool
}

func (v NullableWriterDebugResponse) Get() *WriterDebugResponse {
	return v.value
}

func (v *NullableWriterDebugResponse) Set(val *WriterDebugResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableWriterDebugResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableWriterDebugResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWriterDebugResponse(val *WriterDebugResponse) *NullableWriterDebugResponse {
	return &NullableWriterDebugResponse{value: val, isSet: true}
}

func (v NullableWriterDebugResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWriterDebugResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
